/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.plugins.impl.grid

import metridoc.plugins.Plugin
import metridoc.plugins.grid.Grid
import metridoc.plugins.grid.DefaultGridCreator
import org.apache.camel.Exchange

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 9/15/11
 * Time: 10:38 AM
 * To change this template use File | Settings | File Templates.
 */
@Plugin(value = "grid", properties = "type=hash")
class HashGrid extends DefaultGridCreator implements Grid {

    Iterator<Map<String, Object>> iterator = [].iterator()

    void setHashes(List<Map<String, Object>> hashes) {
        if(hashes) {
            iterator = hashes.iterator()
        }
    }

    LinkedHashSet<String> getColumns() {
        return ["hash"] as LinkedHashSet
    }

    @Override
    Map<String, Object> doNext() {
        return iterator.next()
    }

    @Override
    Grid doCreate(Exchange exchange) {
        def hashes = exchange.in.getBody(List.class)
        return new HashGrid(hashes: hashes)
    }

    @Override
    boolean doHasNext() {
        return iterator.hasNext()
    }
}
